> For a complete page index, fetch https://developer.close.com/llms.txt

# Generate a signed S3 POST

POST https://api.close.com/api/v1/files/upload/
Content-Type: application/json

Get the data needed to make a request to S3 to store your file.

Reference: https://developer.close.com/api/resources/files/create

## Authentication

- `Authorization` header (basic auth, required) — Use your API key as the username and leave the password empty.
- `Authorization` header (bearer token, required)

## Request

### Body (application/json)

- `content_type` (string, required)
- `filename` (string, required)

## Response

### 200

Successful response

## Examples

**Request**

```json
{
  "content_type": "image/jpeg",
  "filename": "image.jpg"
}
```

**Response**

```json
{
  "download": {
    "url": "https://app.close.com/go/file/temporary/user_Ova4RGFG7pztSeJiiMFdN7O2MFl71nD0uGO3bIOo4Wk/1Zx0AlY1DwBXzKKrVwpAoj/image.jpg/"
  },
  "upload": {
    "fields": {
      "AWSAccessKeyId": "AKIAACCESSKEYHERE",
      "Content-Disposition": "inline; filename=\"image.jpg\"",
      "Content-Type": "image/jpeg",
      "key": "temporary/user/user_Ova4RGFG7pztSeJiiMFdN7O2MFl71nD0uGO3bIOo4Wk/1Zx0AlY1DwBXzKKrVwpAoj/image.jpg",
      "policy": "eyJleHBpcmF0aW9uIjogIjIwMjQtMDItMjJ...",
      "signature": "ePInTgHEBsj0hzMeif/d0U2FQQk=",
      "success_action_status": "201"
    },
    "url": "https://close-prd-files.s3.amazonaws.com/"
  }
}
```

**SDK Code**

```python files_create_example
import requests

url = "https://api.close.com/api/v1/files/upload/"

payload = {
    "content_type": "image/jpeg",
    "filename": "image.jpg"
}
headers = {
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers, auth=("<CLOSE_API_KEY>", ""))

print(response.json())
```

```javascript files_create_example
const url = 'https://api.close.com/api/v1/files/upload/';
const credentials = btoa("<CLOSE_API_KEY>:");

const options = {
  method: 'POST',
  headers: {Authorization: `Basic ${credentials}`, 'Content-Type': 'application/json'},
  body: '{"content_type":"image/jpeg","filename":"image.jpg"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go files_create_example
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.close.com/api/v1/files/upload/"

	payload := strings.NewReader("{\n  \"content_type\": \"image/jpeg\",\n  \"filename\": \"image.jpg\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.SetBasicAuth("<CLOSE_API_KEY>", "")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby files_create_example
require 'uri'
require 'net/http'

url = URI("https://api.close.com/api/v1/files/upload/")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request.basic_auth("<CLOSE_API_KEY>", "")
request["Content-Type"] = 'application/json'
request.body = "{\n  \"content_type\": \"image/jpeg\",\n  \"filename\": \"image.jpg\"\n}"

response = http.request(request)
puts response.read_body
```

```java files_create_example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.close.com/api/v1/files/upload/")
  .basicAuth("<CLOSE_API_KEY>", "")
  .header("Content-Type", "application/json")
  .body("{\n  \"content_type\": \"image/jpeg\",\n  \"filename\": \"image.jpg\"\n}")
  .asString();
```

```php files_create_example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.close.com/api/v1/files/upload/', [
  'body' => '{
  "content_type": "image/jpeg",
  "filename": "image.jpg"
}',
  'headers' => [
    'Content-Type' => 'application/json',
  ],
    'auth' => ['<CLOSE_API_KEY>', ''],
]);

echo $response->getBody();
```

```csharp files_create_example
using RestSharp;
using RestSharp.Authenticators;

var client = new RestClient("https://api.close.com/api/v1/files/upload/");
client.Authenticator = new HttpBasicAuthenticator("<CLOSE_API_KEY>", "");
var request = new RestRequest(Method.POST);

request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"content_type\": \"image/jpeg\",\n  \"filename\": \"image.jpg\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```